print("[Barn] Loading.");

if(Barn == nil) then
    Barn = {};
end

local isLocaleSupported = pcall(function()
    local test = Barn.L["ORDER_FUR"];
end);

if(not isLocaleSupported) then
    print("|cFFFF0000[Barn] Locale not supported.|r");
    return;
end


local L = Barn.L;
local GARRISON_MAP_ID = 971;
local icon = "Interface\\GossipFrame\\VendorGossipIcon";
local changeIcon = {
    "ORDER_FUR",
    "ORDER_FUR_LARGE",
    "ORDER_LEATHER",
    "ORDER_LEATHER_LARGE"
};


Barn.frame = CreateFrame("Frame", "BarnFrame", UIParent);
Barn.frame:RegisterEvent("GOSSIP_SHOW");

Barn.frame:SetScript("OnEvent", function()
    local isUsingGarrisonBarn = (GetCurrentMapAreaID() == GARRISON_MAP_ID) and (Barn.getNPCName() == L["NPC_NAME"]);

    if(isUsingGarrisonBarn) then
        for i = 1, NUMGOSSIPBUTTONS do
            local btn = _G["GossipTitleButton" .. i];
            local btnIcon = _G[btn:GetName() .. "GossipIcon"]
            Barn.applyOverride(btn, btnIcon);
        end
    end
end);

Barn.getNPCName = function()
    return GossipFrameNpcNameText:GetText();
end

Barn.applyOverride = function(btn, btnIcon)
    local key = L[ btn:GetText() ];

    if(key ~= nil) then
        btn:SetText( L[key] );
        btn:SetHeight( btn:GetTextHeight() + 2 );

        if( tContains(changeIcon, key) ) then
            btnIcon:SetTexture(icon);
        end
    end
end

-- print("[Barn] Loaded.");